
# --------------------------------------
#   qr_reader_board
#   65f6970e1d39b69dcanv
__canvas_id__ = '65f6970e1d39b69d'
# __version__ = TODO: add this
# --------------------------------------
def _trigger(event, trigger):
  import uasyncio as asyncio
  
  async def hold_trigger():
    trigger(True)  # trigger has inverted logic
    await asyncio.sleep(4)  # wait for 3 seconds
    trigger(False)
  
  if event:
    asyncio.get_event_loop()
    asyncio.create_task(hold_trigger())
  
  
  
from floe import FP

from QrReader import QrReader
from PWM import PWM
from NeoPixel import NeoPixel
from Variable import Variable
from DigitalOutput import DigitalOutput
from DigitalInput import DigitalInput
from CodeBlock import CodeBlock
from HbtLed import HbtLed
from ESP32Core import ESP32Core
from CANBus import CANBus
def setup(iris):
  CANBus(name="CANBus", pid=6545, rx=16, tx=4, adr=25, bus=0, baud=250000, rx_queue=25, terminal_debug=False, debug=False, active=True, bcast=False, iris=iris)
  CodeBlock(name="_trigger", pid=59148, code=_trigger, kwargs=[FP(50038)], datatype="None", iris=iris)
  DigitalInput(name="button_a", pid=12156, pin=22, pullup='pullup', debounce=200, invert=True, initial_value=False, datatype="bool", debug=False, active=True, bcast=True, iris=iris)
  DigitalInput(name="function_button", pid=2276, pin=36, pullup='None', debounce=200, invert=True, initial_value=False, datatype="bool", debug=False, active=True, bcast=True, iris=iris)
  DigitalInput(name="led", pid=39697, pin=26, pullup='None', debounce=200, invert=True, initial_value=False, datatype="bool", debug=False, active=True, bcast=True, iris=iris)
  DigitalInput(name="read", pid=10879, pin=23, pullup='pullup', debounce=200, invert=True, initial_value=False, datatype="bool", debug=True, active=True, bcast=True, iris=iris)
  DigitalOutput(name="can_slp", pid=11397, pin=2, invert=False, initial_value=False, datatype="bool", debug=False, active=True, bcast=False, iris=iris)
  DigitalOutput(name="led_a", pid=58642, pin=18, invert=False, initial_value=False, datatype="bool", debug=False, active=True, bcast=False, iris=iris)
  DigitalOutput(name="trigger", pid=50038, pin=32, invert=True, initial_value=False, datatype="bool", debug=False, active=True, bcast=False, iris=iris)
  ESP32Core(name="ESP32Core", pid=6074, wifi=False, hbt_led=FP(50487), neo_status=FP(47403), function_button=FP(2276), bus=FP(6545), zorg=None, webserver=None, debug=False, active=True, bcast=False, iris=iris)
  HbtLed(name="HbtLed", pid=50487, pin=5, delay=1000, datatype="int", debug=False, active=True, bcast=False, iris=iris)
  NeoPixel(name="neo_status", pid=47403, pin=17, number_of_pixels=1, animation=0, delay=200, animations=None, datatype="rgb", debug=False, active=True, bcast=False, iris=iris)
  PWM(name="buzzer", pid=15083, pin=25, freq=FP(8105), duty=FP(41548), duty_min=0, duty_max=1, invert_duty=False, datatype="bool", debug=False, active=True, bcast=False, iris=iris)
  QrReader(name="QrReader", pid=56632, rx=19, tx=21, uart=1, buzzer_obj=FP(15083), buzz_on_read=True, datatype="string", debug=True, active=True, bcast=True, iris=iris)
  Variable(name="buzz_pitch", pid=8105, state=2500, datatype="int", constant=False, debug=False, active=True, bcast=True, iris=iris)
  Variable(name="do_trigger", pid=46562, state=False, datatype="bool", constant=False, debug=False, active=True, bcast=True, iris=iris)
  Variable(name="volume", pid=41548, state=0.5, datatype="float", constant=False, debug=False, active=True, bcast=True, iris=iris)
  iris.add_hots({"58642": [39697], "50038": [10879], "59148": [46562]})

